mod ast;
mod cli;
mod lexer;
mod parser;
mod prelude;

pub type StdError = dyn std::error::Error;

#[derive(Debug)]
pub struct Error(Box<StdError>);

impl<E: std::error::Error + 'static> From<E> for Error {
    fn from(err: E) -> Self {
        Error(Box::new(err))
    }
}
pub type Result<T> = std::result::Result<T, Error>;

fn main() -> Result<()> {
    Ok(cli::run()?)
}
